﻿@using dbChange.Models.VanPhongSo;
@{
    var vanban = ViewData["vanban"] as VanBan;
    var isScan = Convert.ToInt32(ViewData["isScan"]);
    var IdAccount = Convert.ToInt64(ViewData["IdAccount"]);
    var isNguoiTao = IdAccount == vanban.IdNguoiTao ? 1 : 0;
    var TrangThai = vanban.TrangThai;
}

<script type="text/javascript">
    var IdVanBan = @vanban.Id;
    var isScan = @isScan;
    var isNguoiTao = @isNguoiTao;
    var TrangThai = '@TrangThai';

    function load_danhsach_chitiet_bochungtu(){
      $.ajax({
         url: '@Url.Action("GetAllChiTietVanBan", "VanPhongSo")',
          type: 'GET',
          data: {IdVanBan:IdVanBan},
         dataType: 'json'
      })
          .done(function (response) {
              console.log(response);
            $('#gridContainer').dxDataGrid({
                dataSource: response,
                keyExpr: 'Id',
                showBorders: true,
                showRowLines: true,
                paging: {
                    enabled: false
                },
                
                columnAutoWidth: true,
                columnHidingEnabled: true,
                allowColumnResizing: true,
                columnFixing: {
                    enabled: true
                },
                filterRow: {
                    visible: true,
                    applyFilter: 'auto',
                },
                // filterPanel: { visible: true },
                headerFilter: { visible: true },
                columns:
                    [
                        {
                            headerCellTemplate: function(container) {
                                container.text('STT').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            width: 50,
                            //dataField: "STT",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                              let _stt = options.rowIndex + 1;
                              $(container).html(_stt);
                            }
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('Tiêu đề').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            dataField: "TieuDe",
                            //width: 200,
                            cellTemplate: function (container, options) {
                                $(container).html(options.value);
                            }
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('Nội dung').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            dataField: "NoiDung",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                $(container).html(options.value);
                            }
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('Đường dẫn file đã upload').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            dataField: "Link",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                $(container).html(options.value);
                            }
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('').parent().css({fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd'});
                            },
                            width: 300,
                            //dataField: "",
                            alignment: "right",
                            //cellTemplate: function (container, options) {
                            //    //console.log(options);
                            //    let text_Color_TrangThai = '<div class="btn-group2  btn-group-xs w-100">';
                            //    if (isScan && (TrangThai == "HoanTat")) {
                            //        if (options.data.Link != '' && options.data.Link != null) {
                            //            text_Color_TrangThai += `
                            //            <a class="btn mr-3 btn-success rounded-pill" target='_blank' href="${options.data.LinkShare}">
                            //                <i class="fa fa-eye"></i>Xem file scan
                            //            </a>
                            //            <button type="button" class="btn mr-3 btn-primary rounded-pill btnSaoChepLink" data-link="${options.data.LinkShare}">
                            //                <i class="fa fa-share-alt"></i>Sao chép liên kết
                            //            </button>
                            //        `;
                            //        } else {
                            //            text_Color_TrangThai += `
                            //            <button type="button" class="btn mr-3 btn-danger rounded-pill" >
                            //                <i class="fa fa-times-circle"></i>Chưa có file scan
                            //            </button>
                            //        `;
                            //        }
                            //    }
                            //    text_Color_TrangThai += '</div>';
                            //    $(container).html(text_Color_TrangThai);
                            //}
                            cellTemplate: function (container, options) {
                                //console.log(options);
                                let text_Color_TrangThai = '<div class="btn-group2  btn-group-xs w-100">';
                                let btn_chia_se = "";
                                btn_chia_se = `
                                        <button type="button" class="btn mr-3 btn-primary rounded-pill" data-toggle="modal" data-target="#modal_ChiaSe" data-id="${options.data.Id}" data-maqr="${options.data.MaQR}" data-tieude="${options.data.TieuDe}" data-link="${options.data.LinkShare}">
                                            <i class="fa fa-share-alt"></i>Chia sẻ
                                        </button>
                                    `;
                                if (isNguoiTao) {
                                    // phieu cua minh
                                    if (isScan) {
                                        // co quyen scan
                                        if (options.data.Link != '' && options.data.Link != null) {
                                            // co up file 
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : chia se
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa : chia se, upload
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            }else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : xoa, upload
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn mr-3 btn-outline-danger rounded-pill action_huy_chung_tu" data-id="${options.data.Id}" data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-trash"></i>Xóa
                                                    </button>
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            }
                                        } else {
                                            // chua up file
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : khong co chuc nang
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa : upload
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            }else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : xoa, upload
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn mr-3 btn-outline-danger rounded-pill action_huy_chung_tu" data-id="${options.data.Id}" data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-trash"></i>Xóa
                                                    </button>
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            }
                                        }
                                    } else {
                                        // ko co quyen scan
                                        if (options.data.Link != '' && options.data.Link != null) {
                                            // co up file 
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : chia se
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa : chia se
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                            }else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : xoa
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn mr-3 btn-outline-danger rounded-pill action_huy_chung_tu" data-id="${options.data.Id}" data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-trash"></i>Xóa
                                                    </button>
                                                `;
                                            }
                                        } else {
                                            // chua up file
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : khong co chuc nang
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa : khong co chuc nang
                                            }else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : xoa
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn mr-3 btn-outline-danger rounded-pill action_huy_chung_tu" data-id="${options.data.Id}" data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-trash"></i>Xóa
                                                    </button>
                                                `;
                                            }
                                        }
                                    }
                                } else {
                                    // phieu cua ng khac
                                    if (isScan) {
                                        // co quyen scan
                                        if (options.data.Link != '' && options.data.Link != null) {
                                            // da co file
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : chia se
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa : chia se, upload
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            } else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : xoa, upload
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            }
                                        } else {
                                            // chua co file
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : khong co chuc nang
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa :upload
                                                text_Color_TrangThai += `
                                                    <button type="button" class="btn btn-secondary rounded-pill" data-toggle="modal" data-target="#modal_Upload" data-id="${options.data.Id}"  data-tieude="${options.data.TieuDe}">
                                                        <i class="fa fa-cloud-upload"></i>Upload
                                                    </button>
                                                `;
                                            } else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : khong co chuc nang
                                            }
                                        }
                                    } else {
                                        // ko co quyen scan
                                        if (options.data.Link != '' && options.data.Link != null) {
                                            // da co file
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : chia se
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa : chia se
                                                text_Color_TrangThai += `${btn_chia_se}`;
                                            } else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : khong co chuc nang
                                            }
                                        } else {
                                            // chua co file
                                            if (TrangThai == "HoanTat") {
                                                // trang thai hoan tat : khong co chuc nang
                                            } else if (TrangThai == "DaKhoa") {
                                                // trang thai da khoa :khong co chuc nang
                                            } else if (TrangThai == "MoiTao") {
                                                // truong hop nay la mo khoa : khong co chuc nang
                                            }
                                        }
                                    }
                                }

                                
                                text_Color_TrangThai += '</div>';
                                $(container).html("<h5>"+text_Color_TrangThai+"</h5>");
                            }
                        }
                    ],
                summary: {
                    totalItems:
                        [
                            {
                                column: 'MoTa',
                                summaryType: 'count',
                            }
                        ],
                }
            });
      })
      .fail(function(error) {
         console.log("error", error);
      });
    }
    load_danhsach_chitiet_bochungtu();

    /* Chia sẽ chứng từ */
    $('#modal_ChiaSe').on('show.bs.modal', function (event) {
        $('#modal_ChiaSe .modal-body').html('');
        var button = $(event.relatedTarget);
        var _id = button.data('id');
        var _tieude = button.data('tieude');
        var _maqr = button.data('maqr');
        var _link = button.data('link');
        var modal = $(this);
        //console.log(_id, _tieude, _maqr);
        var kq_maqr = "";
        if(_maqr){
            kq_maqr = `<img class="img-fluid" width="200" src="${_maqr}" >`;
        }else{
            kq_maqr = `<h3 class="text-danger text-center">CHƯA CÓ MÃ QR</h3>`;
        }
        var _html = `
            <h4 class="text-center mb-3"><b class="text-danger">ID: ${_id}</b></h4>
            <h4 class="text-center mb-3">${_tieude}</h4>
            <div class="w-100 text-center">
                ${kq_maqr}
            </div>
            <div class="w-100 text-center">
                <div class="input-group input-group-lg">
                  <div class="input-group-prepend">
                    <span class="input-group-text">Link chia sẻ</span>
                  </div>
                  <textarea class="form-control" readonly>${_link}</textarea>
                </div>
            </div>
        `;
        $('#modal_ChiaSe .modal-body').html(_html);
        // $.ajax({
        //     type : 'POST',
        //     dataType : 'json',
        //     url : _url_,
        //     data : {
        //         id: _id,
        //     },
        //     success : function (res){

        //     },
        //     error : function (){
        //         alert('Có lỗi xảy ra trong quá trình xử lý');
        //     }
        //});
    });
    /* Reset Form modal classify 1*/
    $('#modal_ChiaSe').on('hide.bs.modal', function (event) {
        //$('#modal_ChiaSe .modal-content').html('');
        //alert('Đóng modal nè');
    });
    /* sao chep link */
    $("#gridContainer").on('click', '.btnSaoChepLink', function(e) {
         let _link = $(e.target).attr('data-link');
        navigator.clipboard.writeText(_link);
        alert('Đã sao chép!');
    });
    /* Huỷ chứng từ */
    $("#gridContainer").on('click', '.action_huy_chung_tu', function(e) {
        let _id = $(e.target).attr('data-id');
        let _TieuDe = $(e.target).attr('data-tieude');
        console.log(_id);
        if(_id){
            if(confirm(`Bạn muốn xóa chi tiết này?\nTiêu đề: ${_TieuDe}`)){
                $.ajax({
                    url: '@Url.Action("XoaChiTiet", "VanPhongSo")',
                    type: 'POST',
                    dataType: 'text',
                    data: { Id: _id }
                }).done(function (response) {
                    load_danhsach_chitiet_bochungtu();
                            doNotify("Xóa chi tiết thành công", "success");
                });
            }
        }
        // alert(message?: DOMString);
        /* Act on the event */
    });

    /* Upload */
    $('#modal_Upload').on('show.bs.modal', function (event) {
        $('#modal_Upload .modal-body').html('');
        var button = $(event.relatedTarget);
        var _id = button.data('id');
        var _tieude = button.data('tieude');
        var _maqr = button.data('maqr');
        var modal = $(this);
        //console.log(_id, _tieude, _maqr);
        var _html = "";
        if(_id){
            var _html = `
                <h4 class="text-center mb-3 text-danger">Tiêu đề: ${_tieude}</h4>
                <div class="w-100 text-center">
                    <form action="#" method="post" enctype="multipart/form-data" class="form_Upload" novalidate>
                        <div class="form-group row justify-content-md-center d-none">
                             <div class="col-6">
                                 <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text">Id</span>
                                    </div>
                                    <input type="text" class="form-control id" name="id" value="${_id}" readonly>
                                </div>
                            </div>
                        </div>

                        <div class="form-group row justify-content-md-center">
                            <div class="col-lg-6 col-sm-8 col-12">
                                <div class="input-group">
                                    <div class="col-8">
                                        <input type="file" class="form-control-file" name="file_Upload[]" id="file_Upload" required>
                                        <div class="invalid-feedback">Vui lòng chọn tập tin</div>
                                    </div>

                                    <div class="input-group-prepend">
                                        <button type="submit" class="btn btn-primary">Tải lên</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            `;
        }

        $('#modal_Upload .modal-body').html(_html);
        var forms = document.getElementsByClassName('form_Upload');
        var validation = Array.prototype.filter.call(forms, function(form) {
            form.addEventListener('submit', function(event) {
                if (form.checkValidity() === false) {
                    event.preventDefault();
                    event.stopPropagation();
                }else{
                        event.preventDefault();
                        console.log('gọi ajax');
                        var _form_data = new FormData();
                        /* Read selected files*/
                        _form_data.append('id',$(".form_Upload .id").val());
                        _form_data.append('MaVanBan',$("#MaVanBan").val());

                    var totalfiles = document.getElementById('file_Upload').files.length;
                    console.log(totalfiles);
                        for (var index = 0; index < totalfiles; index++) {
                            _form_data.append("files", document.getElementById('file_Upload').files[index]);
                        }
                        console.log(_form_data);

                    $.ajax({
                        url: '@Url.Action("Upload", "VanPhongSo")',
                        type: 'POST',
                        dataType: 'text',
                        contentType: false,
                        processData: false,
                        data: _form_data,
                        success: function (data) {
                            if (data != "") {
                                $("#modal_Upload").modal('hide');
                                load_danhsach_chitiet_bochungtu();
                                doNotify("Upload thành công", "success");
                            } else {
                                doNotify("Upload không thành công", "danger");
                            }
                        }
                    });
                        //.done(function() {
                        //    $("#modal_Upload").modal('hide');
                        //    load_danhsach_chitiet_bochungtu();
                        //    doNotify("Upload thành công", "success");
                        //})
                        //.fail(function() {
                        //    console.log("error");
                        //})
                        //.always(function() {
                        //    console.log("complete");
                        //});

                    }
                form.classList.add('was-validated');
            }, false);
        });
    });


    (function() {
        'use strict';
        /* Valida form Thêm chứng từ chi tiết */
        window.addEventListener('load', function() {
            var forms = document.getElementsByClassName('form_Them_ChungTu_ChiTiet');
            var validation = Array.prototype.filter.call(forms, function(form) {
                form.addEventListener('submit', function(event) {
                    if (form.checkValidity() === false) {
                        event.preventDefault();
                        event.stopPropagation();
                    }else{
                        event.preventDefault();
                        console.log('gọi ajax');
                        var _form_data = new FormData();
                        /* Read selected files*/
                        _form_data.append('IdVanBan',$(".form_Them_ChungTu_ChiTiet .IdVanBan").val());
                        _form_data.append('TieuDe',$(".form_Them_ChungTu_ChiTiet .TieuDe").val());
                        _form_data.append('NoiDung',$(".form_Them_ChungTu_ChiTiet .NoiDung").val());
                        _form_data.append('MaQuyenVanBan',$(".form_Them_ChungTu_ChiTiet .MaQuyenVanBan").val());

                        /*var totalfiles = document.getElementById('file_dinh_kem').files.length;
                        for (var index = 0; index < totalfiles; index++) {
                            _form_data.append("files[]", document.getElementById('file_dinh_kem').files[index]);
                        }
                        console.log(_form_data);*/

                        $.ajax({
                            url: '@Url.Action("ThemVanBanChiTiet", "VanPhongSo")',
                            type: 'POST',
                            contentType: false,
                            processData: false,
                            data: _form_data,
                            dataType: 'text',
                            success: function (data) {
                                if (data != "") {
                                    doNotify("Thêm chi tiết thành công", "success");
                                    setTimeout(function () { window.location.reload() }, 1000);
                                } else {
                                    doNotify("Thêm chi tiết không thành công", "danger");
                                }
                            }
                        });
                    }
                    form.classList.add('was-validated');
                }, false);
            });
        }, false);

        /* Valida form Cập nhật bộ chứng từ */
        window.addEventListener('load', function() {
            var forms = document.getElementsByClassName('form_CapNhat_BoChungTu');
            var validation = Array.prototype.filter.call(forms, function(form) {
                form.addEventListener('submit', function(event) {
                    if (form.checkValidity() === false) {
                        event.preventDefault();
                        event.stopPropagation();
                    }
                    form.classList.add('was-validated');
                }, false);
            });
        }, false);
    })();


    $('.btnLuuPhieu').click(function (event) {
        var forms = document.getElementsByClassName('form_CapNhat_BoChungTu');
        var validation = Array.prototype.filter.call(forms, function(form) {
                if (form.checkValidity() === false) {
                        event.preventDefault();
                        event.stopPropagation();
                    }else{
                        event.preventDefault();
                        console.log('gọi ajax');
                        let _data = {
                                IdVanBan: $(".form_Them_ChungTu_ChiTiet .IdVanBan").val(),
                                TieuDe: $(".form_CapNhat_BoChungTu .TieuDe").val(),
                                NoiDung: $(".form_CapNhat_BoChungTu .NoiDung").val(),
                                GhiChu: $(".form_CapNhat_BoChungTu .GhiChu").val(),
                                MaQuyenVanBan: $(".form_CapNhat_BoChungTu .MaQuyenVanBan").val()
                        };
                        console.log(_data);

                        $.ajax({
                            url: '@Url.Action("CapNhatPhieuDangKy", "VanPhongSo")',
                            type: 'POST',
                            dataType: 'json',
                            data: _data,
                        })
                            .done(function (res) {
                                console.log(res);
                            
                            doNotify("Lưu thành công", "success");
                        })
                        .fail(function() {
                            console.log("error");
                        })
                        .always(function() {
                            console.log("complete");
                        });

                    }
                    form.classList.add('was-validated');
            });
    });
    $('.btnKhoaPhieu').click(function (event) {
        var forms = document.getElementsByClassName('form_CapNhat_BoChungTu');
        var validation = Array.prototype.filter.call(forms, function(form) {
                if (form.checkValidity() === false) {
                        event.preventDefault();
                        event.stopPropagation();
                }else{
                        event.preventDefault();
                        console.log('gọi ajax');
                        let _data = {
                                IdVanBan: $(".form_Them_ChungTu_ChiTiet .IdVanBan").val()
                        };
                        console.log(_data);

                    $.ajax({
                        url: '@Url.Action("KhoaPhieuDangKy", "VanPhongSo")',
                        type: 'POST',
                        dataType: 'json',
                        data: _data,
                        success: function () {
                            doNotify("Khóa phiếu thành công", "success");
                            setTimeout(function () { window.location.reload() }, 1000);
                        }
                    });
                }
                form.classList.add('was-validated');
        });
    });
    
</script>